/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package singletonimproved;

import java.util.*;
import singletonimproved.RuleSystemEnum;

/**
 *
 * @author chris
 */
public class RuleSystems {

  private static volatile HashMap<RuleSystemEnum, IRuleSystem> ruleSystems;

  public RuleSystems() {
  }

  private static synchronized void initializeInstance() {
    ruleSystems = new HashMap(2);
    ruleSystems.put(RuleSystemEnum.SUPER, new SuperRuleSystem());
    ruleSystems.put(RuleSystemEnum.FANTASY, new FantasyRuleSystem());
  }

  public static IRuleSystem getInstance(RuleSystemEnum system) {
    IRuleSystem returnValue = null;
    if (ruleSystems == null) {
      initializeInstance();
    }

    returnValue = ruleSystems.get(system);

    return returnValue;
  }
}
